#ifndef DOORSOS_H
#define DOORSOS_H


typedef struct{
  ushort nboffsets;
  ushort* offsets;
}reloc;

typedef struct{
  ushort funcindex;
  reloc reltable;
}reloc_sym;

typedef struct{
  ushort nbfunc;  // nb of indexes used - 1
  reloc_sym** table;
}reloc_module;

typedef struct{
  ushort nblibs;
  char** libs_names;
  reloc_module** lib_reloc;  
}import;

typedef struct{
  ushort flag;
  reloc_module* ROM_reloc;
}ROM;

typedef struct{
  ushort flag;
  reloc_module* RAM32_reloc;
  reloc_module* RAM16_reloc;
}RAM;

typedef struct{
  ulong size;	// size of the BSS block to allocate
  reloc* BSS_reloc;
}BSStable;

typedef struct{
  ushort bsr;
  ushort bsr_offset;
  uchar sign[4];
  ushort relcnt;
  ushort comment_offset;
  ushort main_offset;
  ushort exit_offset;
  ushort flags;
  ushort bss_hdl;
  ushort bss_offset;
  ushort export_offset;
  ushort extraRAM_offset;
  import* importtable;
  ROM* romtable;
  RAM* ramtable;
  reloc* reloctable;
  BSStable* bss;
  reloc* exporttable;

  uchar* stub;
  uchar* code;
  ushort stubsize;
  ushort codesize;
  ushort nostub;
}ASM;

typedef struct{
  ushort	size;
  ASM*		raw;
}filecore;

typedef struct{
  uchar		signature[8];
  ushort 	unused1;
  uchar		folder[8];
  char		desc[40];
  char		unused2[6];
  char		file[8];
  long		type;
  long		size;
  char		unused3[6];
  filecore*	core;
  ushort	checksum;
}TIfile;


#endif
