#ifndef LINK_H
#define LINK_H

typedef char BOOL;
#define TRUE 1
#define FALSE 0

#include "objimage.h"

int exist(char* name);

objfile* read_object(char* name);
void delete_objfile(objfile* object);

long* check_am_sec(long*, objfile*);
long* load_am_sec(long*, objimage*, ushort);

void* alloc(size_t);
void* re_alloc(void*,size_t);
void del_extension(char*);
ushort rus(ushort);                 // Conversion ushort Intel <-> Motorola
ulong rul(ulong);                   // Conversion ulong Intel <-> Motorola
ushort* rusp(ushort*);
ulong* rulp(ulong*);

int nb_prv_sym(objfile*);
int nb_pub_sym(objfile*);
int nb_unr_sym(objfile*);
int nb_bss_sym(objfile*);

int nb_prv_rel(struct external_scnhdr*, objfile*);
int nb_unr_rel(struct external_scnhdr*, objfile*);
int nb_bss_rel(struct external_scnhdr*, objfile*);

int is_sym_prv(struct external_syment*);  // retourne 0 si oui, !=0 si non
int is_sym_pub(struct external_syment*);
int is_sym_unr(struct external_syment*);
int is_sym_bss(struct external_syment*);
int is_sym_sec(struct external_syment*);

int is_bss_unr(struct external_syment*);
int is_bss_pub(struct external_syment*);
int is_bss_true(struct external_syment*);

char* get_sym_name(struct external_syment*);
int is_lib_name(char*);

unresolved* add_ext_sym(objimage*, char*);
void add_pub_sym(objimage*, char*, ulong, ushort);

void add_rel_prv(objimage*, ulong, ushort, ushort);
void add_rel_bss(objimage*, ulong, ushort);
void add_rel_unr(objimage*, ulong, unresolved*, ushort, ushort);
char* conv_oldlib_names(char*); // converts lib@xxxx to lib__xxxx

#endif
